Index: src/player_gui.cpp
===================================================================
--- src/player_gui.cpp	(revision 13683)
+++ src/player_gui.cpp	(working copy)
@@ -29,6 +29,7 @@
 #include "widgets/dropdown_func.h"
 #include "widgets/dropdown_type.h"
 #include "tilehighlight_func.h"
+#include "sharedinfrastructure.h"
 
 #include "table/sprites.h"
 #include "table/strings.h"
@@ -1036,7 +1037,436 @@
 	new SelectPlayerFaceWindow(adv ? &_select_player_face_adv_desc : &_select_player_face_desc, parent, adv, top, left); // simple or advanced window
 }
 
+/** Widget description for the shared infrastructure selection dialog */
+static const Widget _shared_infrastructure_widgets[] = {
+{   WWT_CLOSEBOX,   RESIZE_NONE,   14,     0,   10,     0,   13, STR_00C5,                            STR_018B_CLOSE_WINDOW},              // SI_WIDGET_CLOSEBOX
+{    WWT_CAPTION,   RESIZE_NONE,   14,    11,  269,     0,   13, STR_SHARED_INFRASTRUCTURE_SELECTION, STR_018C_WINDOW_TITLE_DRAG_THIS},    // SI_WIDGET_CAPTION
+{      WWT_PANEL,   RESIZE_NONE,   14,     0,  269,    14,   64, 0x0,                                 STR_NULL},                           // SI_WIDGET_SELECT_SHARING_TRAIN
+{      WWT_PANEL,   RESIZE_NONE,   14,     0,  269,    65,   91, 0x0,                                 STR_NULL},                           // SI_WIDGET_SELECT_SHARING_AIR
+{      WWT_PANEL,   RESIZE_NONE,   14,     0,  269,    92,  130, 0x0,                                 STR_NULL},                           // SI_WIDGET_SELECT_SHARING_ROAD
+{      WWT_PANEL,   RESIZE_NONE,   14,     0,  269,   131,  169, 0x0,                                 STR_NULL},                           // SI_WIDGET_SELECT_SHARING_SHIP
+{      WWT_PANEL,   RESIZE_NONE,   14,     0,  269,   170,  206, 0x0,                                 STR_NULL},                           // SI_WIDGET_SELECT_SHARING_GENERAL
+{ WWT_PUSHTXTBTN,   RESIZE_NONE,   14,     0,   94,   195,  206, STR_012E_CANCEL,                     STR_NULL},                           // SI_WIDGET_CANCEL
+{ WWT_PUSHTXTBTN,   RESIZE_NONE,   14,    95,  269,   195,  206, STR_012F_OK,                         STR_SHARED_ACCEPT},                  // SI_WIDGET_ACCEPT
+{     WWT_IMGBTN,   RESIZE_NONE,   14,     2,   23,    16,   37, SPR_IMG_TRAINLIST,                   STR_NULL},                           // SI_WIDGET_TRAIN
+{     WWT_IMGBTN,   RESIZE_NONE,   14,     2,   23,    67,   88, SPR_IMG_AIRPLANESLIST,               STR_NULL},                           // SI_WIDGET_PLANE
+{     WWT_IMGBTN,   RESIZE_NONE,   14,     2,   23,    94,  115, SPR_IMG_TRUCKLIST,                   STR_NULL},                           // SI_WIDGET_ROAD
+{     WWT_IMGBTN,   RESIZE_NONE,   14,     2,   23,   133,  154, SPR_IMG_SHIPLIST,                    STR_NULL},                           // SI_WIDGET_SHIP
+{     WWT_IMGBTN,   RESIZE_NONE,   14,     2,   23,   172,  193, SPR_IMG_COMPANY_GENERAL,             STR_NULL},                           // SI_WIDGET_GENERAL
+{ WWT_PUSHTXTBTN,   RESIZE_NONE,   14,   175,  267,    16,   27, STR_EMPTY,                           STR_SHARED_RAILWAY_TRACKS},          // SI_WIDGET_SHARED_RAILWAY_TRACKS
+{ WWT_PUSHTXTBTN,   RESIZE_NONE,   14,   175,  267,    28,   39, STR_EMPTY,                           STR_SHARED_RAILWAY_STATIONS},        // SI_WIDGET_SHARED_RAILWAY_STATION
+{ WWT_PUSHTXTBTN,   RESIZE_NONE,   14,   175,  267,    40,   51, STR_EMPTY,                           STR_SHARED_RAILWAY_DEPOTS},          // SI_WIDGET_SHARED_RAILWAY_DEPOTS
+{ WWT_PUSHTXTBTN,   RESIZE_NONE,   14,   175,  267,    67,   78, STR_EMPTY,                           STR_SHARED_AIRPORTS},                // SI_WIDGET_SHARED_AIRPORTS
+{ WWT_PUSHTXTBTN,   RESIZE_NONE,   14,   175,  267,    94,  105, STR_EMPTY,                           STR_SHARED_ROAD_DEPOTS},             // SI_WIDGET_SHARED_ROAD_DEPOTS
+{ WWT_PUSHTXTBTN,   RESIZE_NONE,   14,   175,  267,   106,  117, STR_EMPTY,                           STR_SHARED_ROAD_STOPS},              // SI_WIDGET_SHARED_ROAD_STOPS
+{ WWT_PUSHTXTBTN,   RESIZE_NONE,   14,   175,  267,   133,  144, STR_EMPTY,                           STR_SHARED_WATER_DEPOTS},            // SI_WIDGET_SHARED_WATER_DEPOTS
+{ WWT_PUSHTXTBTN,   RESIZE_NONE,   14,   175,  267,   145,  156, STR_EMPTY,                           STR_SHARED_HARBOURS},                // SI_WIDGET_SHARED_HARBOURS
+{ WWT_PUSHIMGBTN,   RESIZE_NONE,   14,   175,  183,    52,   63, SPR_ARROW_LEFT,                      STR_SHARED_TONTILE_COST},            // SI_WIDGET_SHARED_TONTILE_COST_L
+{ WWT_PUSHTXTBTN,   RESIZE_NONE,   14,   184,  258,    52,   63, STR_EMPTY,                           STR_SHARED_TONTILE_COST},            // SI_WIDGET_SHARED_TONTILE_COST
+{ WWT_PUSHIMGBTN,   RESIZE_NONE,   14,   259,  267,    52,   63, SPR_ARROW_RIGHT,                     STR_SHARED_TONTILE_COST},            // SI_WIDGET_SHARED_TONTILE_COST_R
+{ WWT_PUSHIMGBTN,   RESIZE_NONE,   14,   175,  183,   118,  129, SPR_ARROW_LEFT,                      STR_SHARED_ROAD_STOPS_FEE},          // SI_WIDGET_SHARED_ROAD_STOPS_FEE_L
+{ WWT_PUSHTXTBTN,   RESIZE_NONE,   14,   184,  258,   118,  129, STR_EMPTY,                           STR_SHARED_ROAD_STOPS_FEE},          // SI_WIDGET_SHARED_ROAD_STOPS_FEE
+{ WWT_PUSHIMGBTN,   RESIZE_NONE,   14,   259,  267,   118,  129, SPR_ARROW_RIGHT,                     STR_SHARED_ROAD_STOPS_FEE},          // SI_WIDGET_SHARED_ROAD_STOPS_FEE_R
+{ WWT_PUSHIMGBTN,   RESIZE_NONE,   14,   175,  183,   157,  168, SPR_ARROW_LEFT,                      STR_SHARED_HARBOURS_FEE},         // SI_WIDGET_SHARED_HARBOURS_FEE_L
+{ WWT_PUSHTXTBTN,   RESIZE_NONE,   14,   184,  258,   157,  168, STR_EMPTY,                           STR_SHARED_HARBOURS_FEE},         // SI_WIDGET_SHARED_HARBOURS_FEE
+{ WWT_PUSHIMGBTN,   RESIZE_NONE,   14,   259,  267,   157,  168, SPR_ARROW_RIGHT,                     STR_SHARED_HARBOURS_FEE},         // SI_WIDGET_SHARED_HARBOURS_FEE_R
+{ WWT_PUSHIMGBTN,   RESIZE_NONE,   14,   175,  183,    79,   90, SPR_ARROW_LEFT,                      STR_SHARED_LANDING_FEE},             // SI_WIDGET_SHARED_LANDING_FEE_L
+{ WWT_PUSHTXTBTN,   RESIZE_NONE,   14,   184,  258,    79,   90, STR_EMPTY,                           STR_SHARED_LANDING_FEE},             // SI_WIDGET_SHARED_LANDING_FEE
+{ WWT_PUSHIMGBTN,   RESIZE_NONE,   14,   259,  267,    79,   90, SPR_ARROW_RIGHT,                     STR_SHARED_LANDING_FEE},             // SI_WIDGET_SHARED_LANDING_FEE_R
+{ WWT_PUSHIMGBTN,   RESIZE_NONE,   14,   175,  183,   172,  183, SPR_ARROW_LEFT,                      STR_SHARED_DEPOT_PROVISION},         // SI_WIDGET_SHARED_DEPOT_PROVISION_L
+{ WWT_PUSHTXTBTN,   RESIZE_NONE,   14,   184,  258,   172,  183, STR_EMPTY,                           STR_SHARED_DEPOT_PROVISION},         // SI_WIDGET_SHARED_DEPOT_PROVISION
+{ WWT_PUSHIMGBTN,   RESIZE_NONE,   14,   259,  267,   172,  183, SPR_ARROW_RIGHT,                     STR_SHARED_DEPOT_PROVISION},         // SI_WIDGET_SHARED_DEPOT_PROVISION_R
+{   WIDGETS_END},
+};
 
+class SelectSharedInfrastructureWindow : public Window
+{
+	/* check for variable recording */
+	uint32 new_value;
+	uint32 old_value;
+	uint32 new_value2;
+	uint32 old_value2;
+
+	/**
+	 * Shared infrastructure player settings
+	 * Widgets section. Keep them in the same order in the widget array
+	 */
+	enum SharedInfrastructureWindowWidgets {
+		SI_WIDGET_CLOSEBOX = 0,
+		SI_WIDGET_CAPTION,	
+		SI_WIDGET_SELECT_SHARING_TRAIN,
+		SI_WIDGET_SELECT_SHARING_AIR,
+		SI_WIDGET_SELECT_SHARING_ROAD,
+		SI_WIDGET_SELECT_SHARING_SHIP,
+		SI_WIDGET_SELECT_SHARING_GENERAL,
+		SI_WIDGET_CANCEL,
+		SI_WIDGET_ACCEPT,
+		SI_WIDGET_TRAIN,
+		SI_WIDGET_PLANE,
+		SI_WIDGET_ROAD,
+		SI_WIDGET_SHIP,
+		SI_WIDGET_GENERAL,
+		SI_WIDGET_SHARED_RAILWAY_TRACKS,
+		SI_WIDGET_SHARED_RAILWAY_STATIONS,
+		SI_WIDGET_SHARED_RAILWAY_DEPOTS,
+		SI_WIDGET_SHARED_AIRPORTS,
+		SI_WIDGET_SHARED_ROAD_DEPOTS,
+		SI_WIDGET_SHARED_ROAD_STOPS,
+		SI_WIDGET_SHARED_WATER_DEPOTS,
+		SI_WIDGET_SHARED_HARBOURS,
+		SI_WIDGET_SHARED_TONTILE_COST_L,
+		SI_WIDGET_SHARED_TONTILE_COST,
+		SI_WIDGET_SHARED_TONTILE_COST_R,
+		SI_WIDGET_SHARED_ROAD_STOPS_FEE_L,
+		SI_WIDGET_SHARED_ROAD_STOPS_FEE,
+		SI_WIDGET_SHARED_ROAD_STOPS_FEE_R,
+		SI_WIDGET_SHARED_HARBOURS_FEE_L,
+		SI_WIDGET_SHARED_HARBOURS_FEE,
+		SI_WIDGET_SHARED_HARBOURS_FEE_R,
+		SI_WIDGET_SHARED_LANDING_FEE_L,
+		SI_WIDGET_SHARED_LANDING_FEE,
+		SI_WIDGET_SHARED_LANDING_FEE_R,
+		SI_WIDGET_SHARED_DEPOT_PROVISION_L,
+		SI_WIDGET_SHARED_DEPOT_PROVISION,
+		SI_WIDGET_SHARED_DEPOT_PROVISION_R,
+	};
+
+	enum {
+		SI_SETTING_DEFAULT,
+		SI_SETTING_VELOCITY,
+		SI_SETTING_CURRENCY
+	};
+
+	/**
+	 * Draw dynamic a label to the left of the button and a value in the button
+	 *
+	 * @param widget_index   index of this widget in the window
+	 * @param val            the value which will be draw
+	 * @param is_bool_widget is it a bool button
+	 * @param special        value is special (currency, velocity)
+	 */
+	void DrawSharedinfrastructureLabel(byte widget_index, uint16 val, bool is_bool_widget, byte special)
+	{
+		StringID str;
+
+		if (is_bool_widget) {
+			/* if it a bool button write yes or no */
+			str = (val != 0) ? STR_FACE_YES : STR_FACE_NO;
+		} else {
+			/* else write the value */
+			SetDParam(0, val);
+			switch (special) {
+				case SI_SETTING_VELOCITY : str = STR_JUST_VELOCITY; break;
+				case SI_SETTING_CURRENCY : str = STR_JUST_CURRENCY; break;
+				default : str = STR_JUST_INT;
+			}
+		}
+
+		/* Draw the value/bool in white (0xC). If the button clicked adds 1px to x and y text coordinates (IsWindowWidgetLowered()). */
+		DrawStringCentered(this->widget[widget_index].left + (this->widget[widget_index].right - this->widget[widget_index].left) / 2 +
+			this->IsWidgetLowered(widget_index), this->widget[widget_index].top + 1 + this->IsWidgetLowered(widget_index), str, TC_WHITE);
+	}
+
+public:
+	SelectSharedInfrastructureWindow(const WindowDesc *desc, Window *parent) : Window(desc, parent->window_number)
+	{
+		this->parent = parent;
+		this->FindWindowPlacementAndResize(desc);
+		this->caption_color = this->window_number;
+
+		const Player *p = GetPlayer((PlayerID)this->window_number);
+		bool local = this->window_number == _local_player;
+		
+		this->new_value = 0;
+		this->old_value = 0;
+		this->new_value2 = 0;
+		this->old_value2 = 0;
+
+		/* Check if repositioning from default is required */
+		if (top != FIRST_GUI_CALL && left != FIRST_GUI_CALL) {
+			this->top = top;
+			this->left = left;
+		}
+		
+		if (local) {
+			_si_railway_tracks = p->shared_railway_tracks[1];
+			_si_railway_stations = p->shared_railway_stations[1];
+			_si_railway_depots = p->shared_railway_depots[1];
+			_si_tontile_cost = p->shared_tontile_cost[1];
+			_si_road_stops_fee = p->shared_road_stops_fee[1];
+			_si_harbours_fee = p->shared_harbours_fee[1];
+			_si_airports = p->shared_airports[1];
+			_si_landing_fee = p->shared_landing_fee[1];
+			_si_road_depots = p->shared_road_depots[1];
+			_si_road_stops = p->shared_road_stops[1];
+			_si_water_depots = p->shared_water_depots[1];
+			_si_harbours = p->shared_harbours[1];
+			_si_provision = p->shared_provision[1];
+		}	
+	}
+
+	virtual void OnPaint()
+	{
+		const Player *p = GetPlayer((PlayerID)this->window_number);
+		bool local = this->window_number == _local_player;
+
+		uint i;
+
+		/* hide and disabled widget for non-local players */
+		for (i = SI_WIDGET_SHARED_TONTILE_COST_L; i <= SI_WIDGET_SHARED_DEPOT_PROVISION_R; i++) {
+			this->SetWidgetDisabledState(i, !local);
+		}
+		this->SetWidgetHiddenState(SI_WIDGET_CANCEL, !local);
+		this->SetWidgetHiddenState(SI_WIDGET_ACCEPT, !local);
+			
+		/* disabled widget from general (patch) settings */
+		this->SetWidgetDisabledState(SI_WIDGET_SHARED_RAILWAY_TRACKS, !local || !_settings_game.sharing.shared_railway_tracks);
+		this->SetWidgetDisabledState(SI_WIDGET_SHARED_RAILWAY_STATIONS, !local || !_settings_game.sharing.shared_railway_stations);
+		this->SetWidgetDisabledState(SI_WIDGET_SHARED_RAILWAY_DEPOTS, !local || !_settings_game.sharing.shared_railway_depots);
+		this->SetWidgetDisabledState(SI_WIDGET_SHARED_AIRPORTS, !local || !_settings_game.sharing.shared_airports);
+		this->SetWidgetDisabledState(SI_WIDGET_SHARED_ROAD_DEPOTS, !local || !_settings_game.sharing.shared_road_depots);
+		this->SetWidgetDisabledState(SI_WIDGET_SHARED_ROAD_STOPS, !local || !_settings_game.sharing.shared_road_stops);
+		this->SetWidgetDisabledState(SI_WIDGET_SHARED_WATER_DEPOTS, !local || !_settings_game.sharing.shared_water_depots);
+		this->SetWidgetDisabledState(SI_WIDGET_SHARED_HARBOURS, !local || !_settings_game.sharing.shared_harbours);
+
+		this->DrawWidgets();
+
+		/* "shared tracks:" */
+		DrawString(26, 16, STR_CONFIG_PLAYER_SHARED_RAILWAY_TRACKS, TC_FROMSTRING);
+		DrawStringCentered(140, 16, p->shared_railway_tracks[0] ? STR_FACE_YES : STR_FACE_NO, TC_WHITE);
+
+		/* "shared stations:" */
+		DrawString(26, 28, STR_CONFIG_PLAYER_SHARED_RAILWAY_STATIONS, TC_FROMSTRING);
+		DrawStringCentered(140, 28, p->shared_railway_stations[0] ? STR_FACE_YES : STR_FACE_NO, TC_WHITE);
+
+		/* "shared rail depots:" */
+		DrawString(26, 40, STR_CONFIG_PLAYER_SHARED_RAILWAY_DEPOTS, TC_FROMSTRING);
+		DrawStringCentered(140, 40, p->shared_railway_depots[0] ? STR_FACE_YES : STR_FACE_NO, TC_WHITE);
+
+		/* "shared rail tontile:" */
+		DrawString(26, 52, STR_CONFIG_PLAYER_SHARED_TONTILE_COST, TC_FROMSTRING);
+		SetDParam(0, p->shared_tontile_cost[0]);
+		DrawStringCentered(140, 52, STR_JUST_CURRENCY, TC_WHITE);
+
+		/* "shared road stops fee:" */
+		DrawString(26, 118, STR_CONFIG_PLAYER_SHARED_ROAD_STOPS_FEE, TC_FROMSTRING);
+		SetDParam(0, p->shared_road_stops_fee[0]);
+		DrawStringCentered(140, 118, STR_JUST_CURRENCY, TC_WHITE);
+
+		/* "shared harbours fee:" */
+		DrawString(26, 157, STR_CONFIG_PLAYER_SHARED_HARBOURS_FEE, TC_FROMSTRING);
+		SetDParam(0, p->shared_harbours_fee[0]);
+		DrawStringCentered(140, 157, STR_JUST_CURRENCY, TC_WHITE);
+
+		/* "shared airports:" */
+		DrawString(26, 67, STR_CONFIG_PLAYER_SHARED_AIRPORTS, TC_FROMSTRING);
+		DrawStringCentered(140, 67, p->shared_airports[0] ? STR_FACE_YES : STR_FACE_NO, TC_WHITE);
+
+		/* "shared landing fee:" */
+		DrawString(26, 79, STR_CONFIG_PLAYER_SHARED_LANDING_FEE, TC_FROMSTRING);
+		SetDParam(0, p->shared_landing_fee[0]);
+		DrawStringCentered(140, 79, STR_JUST_CURRENCY, TC_WHITE);
+
+		/* "shared road depots:" */
+		DrawString(26, 94, STR_CONFIG_PLAYER_SHARED_ROAD_DEPOTS, TC_FROMSTRING);
+		DrawStringCentered(140, 94, p->shared_road_depots[0] ? STR_FACE_YES : STR_FACE_NO, TC_WHITE);
+
+		/* "shared road stops:" */
+		DrawString(26, 106, STR_CONFIG_PLAYER_SHARED_ROAD_STOPS, TC_FROMSTRING);
+		DrawStringCentered(140, 106, p->shared_road_stops[0] ? STR_FACE_YES : STR_FACE_NO, TC_WHITE);
+
+		/* "shared water depots:" */
+		DrawString(26, 133, STR_CONFIG_PLAYER_SHARED_WATER_DEPOTS, TC_FROMSTRING);
+		DrawStringCentered(140, 133, p->shared_water_depots[0] ? STR_FACE_YES : STR_FACE_NO, TC_WHITE);
+
+		/* "shared harbours:" */
+		DrawString(26, 145, STR_CONFIG_PLAYER_SHARED_HARBOURS, TC_FROMSTRING);
+		DrawStringCentered(140, 145, p->shared_harbours[0] ? STR_FACE_YES : STR_FACE_NO, TC_WHITE);
+
+		/* "shared depot provision:" */
+		DrawString(26, 172, STR_CONFIG_PLAYER_SHARED_DEPOT_PROVISION, TC_FROMSTRING);
+		SetDParam(0, p->shared_provision[0]);
+		DrawStringCentered(140, 172, STR_JUST_PERCENT, TC_WHITE);
+
+		/* "shared planned change:" */
+		if (_settings_game.sharing.shared_delay > 0) {
+			if (p->shared_change_months > 0) {
+				SetDParam(0, p->shared_change_months);
+				DrawString(26, 184, STR_CONFIG_PLAYER_SHARED_CHANGE_MONTHS, TC_FROMSTRING);
+			} else {
+				SetDParam(0, _settings_game.sharing.shared_delay);
+				DrawString(26, 184, STR_CONFIG_PLAYER_SHARED_NO_CHANGE, TC_FROMSTRING);
+			}
+		}
+
+		/**
+		 * Draw value
+		 * use variables for local change
+		 */
+
+		if (local) {
+			this->DrawSharedinfrastructureLabel(SI_WIDGET_SHARED_RAILWAY_TRACKS, _si_railway_tracks, true, SI_SETTING_DEFAULT );
+			this->DrawSharedinfrastructureLabel(SI_WIDGET_SHARED_RAILWAY_STATIONS, _si_railway_stations, true, SI_SETTING_DEFAULT );
+			this->DrawSharedinfrastructureLabel(SI_WIDGET_SHARED_RAILWAY_DEPOTS, _si_railway_depots, true, SI_SETTING_DEFAULT );
+			this->DrawSharedinfrastructureLabel(SI_WIDGET_SHARED_TONTILE_COST, _si_tontile_cost, false, SI_SETTING_CURRENCY );
+			this->DrawSharedinfrastructureLabel(SI_WIDGET_SHARED_ROAD_STOPS_FEE, _si_road_stops_fee, false, SI_SETTING_CURRENCY );
+			this->DrawSharedinfrastructureLabel(SI_WIDGET_SHARED_HARBOURS_FEE, _si_harbours_fee, false , SI_SETTING_CURRENCY);
+			this->DrawSharedinfrastructureLabel(SI_WIDGET_SHARED_AIRPORTS, _si_airports, true, SI_SETTING_DEFAULT );
+			this->DrawSharedinfrastructureLabel(SI_WIDGET_SHARED_LANDING_FEE, _si_landing_fee, false , SI_SETTING_CURRENCY);
+			this->DrawSharedinfrastructureLabel(SI_WIDGET_SHARED_ROAD_DEPOTS, _si_road_depots, true, SI_SETTING_DEFAULT );
+			this->DrawSharedinfrastructureLabel(SI_WIDGET_SHARED_ROAD_STOPS, _si_road_stops, true, SI_SETTING_DEFAULT );
+			this->DrawSharedinfrastructureLabel(SI_WIDGET_SHARED_WATER_DEPOTS, _si_water_depots, true, SI_SETTING_DEFAULT );
+			this->DrawSharedinfrastructureLabel(SI_WIDGET_SHARED_HARBOURS, _si_harbours, true, SI_SETTING_DEFAULT );
+			this->DrawSharedinfrastructureLabel(SI_WIDGET_SHARED_DEPOT_PROVISION, _si_provision, false, SI_SETTING_DEFAULT );
+		} else {
+			this->DrawSharedinfrastructureLabel(SI_WIDGET_SHARED_RAILWAY_TRACKS, p->shared_railway_tracks[1], true, SI_SETTING_DEFAULT );
+			this->DrawSharedinfrastructureLabel(SI_WIDGET_SHARED_RAILWAY_STATIONS, p->shared_railway_stations[1], true, SI_SETTING_DEFAULT );
+			this->DrawSharedinfrastructureLabel(SI_WIDGET_SHARED_RAILWAY_DEPOTS, p->shared_railway_depots[1], true, SI_SETTING_DEFAULT );
+			this->DrawSharedinfrastructureLabel(SI_WIDGET_SHARED_TONTILE_COST, p->shared_tontile_cost[1], false, SI_SETTING_CURRENCY );
+			this->DrawSharedinfrastructureLabel(SI_WIDGET_SHARED_ROAD_STOPS_FEE, p->shared_road_stops_fee[1], false, SI_SETTING_CURRENCY );
+			this->DrawSharedinfrastructureLabel(SI_WIDGET_SHARED_HARBOURS_FEE, p->shared_harbours_fee[1], false , SI_SETTING_CURRENCY);
+			this->DrawSharedinfrastructureLabel(SI_WIDGET_SHARED_AIRPORTS, p->shared_airports[1], true, SI_SETTING_DEFAULT );
+			this->DrawSharedinfrastructureLabel(SI_WIDGET_SHARED_LANDING_FEE, p->shared_landing_fee[1], false , SI_SETTING_CURRENCY);
+			this->DrawSharedinfrastructureLabel(SI_WIDGET_SHARED_ROAD_DEPOTS, p->shared_road_depots[1], true, SI_SETTING_DEFAULT );
+			this->DrawSharedinfrastructureLabel(SI_WIDGET_SHARED_ROAD_STOPS, p->shared_road_stops[1], true, SI_SETTING_DEFAULT );
+			this->DrawSharedinfrastructureLabel(SI_WIDGET_SHARED_WATER_DEPOTS, p->shared_water_depots[1], true, SI_SETTING_DEFAULT );
+			this->DrawSharedinfrastructureLabel(SI_WIDGET_SHARED_HARBOURS, p->shared_harbours[1], true, SI_SETTING_DEFAULT );
+			this->DrawSharedinfrastructureLabel(SI_WIDGET_SHARED_DEPOT_PROVISION, p->shared_provision[1], false, SI_SETTING_DEFAULT );
+		}
+	}
+
+	virtual void OnClick(Point pt, int widget)
+	{
+		const Player *p = GetPlayer((PlayerID)this->window_number);
+		switch (widget) {
+
+			/* Cancel button */
+			case SI_WIDGET_CANCEL:
+				delete this;
+				break;
+
+			/* OK button */
+			case SI_WIDGET_ACCEPT:
+				/**
+				 * record changed values
+				 * first pack boolean variables
+				 * and check for change before sending command
+				 */
+				new_value = (uint)_si_railway_tracks | (uint)_si_railway_stations << 1 | (uint)_si_railway_depots << 2
+					| (uint)_si_airports << 3 | (uint)_si_road_depots << 4 | (uint)_si_road_stops << 5
+					 | (uint)_si_water_depots << 6 | (uint)_si_harbours << 7;
+				old_value = (uint)p->shared_railway_tracks[1] | (uint)p->shared_railway_stations[1] << 1 | (uint)p->shared_railway_depots[1] << 2
+					 | (uint)p->shared_airports[1] << 3 | (uint)p->shared_road_depots[1] << 4 | (uint)p->shared_road_stops[1] << 5
+					 | (uint)p->shared_water_depots[1] << 6 | (uint)p->shared_harbours[1] << 7;
+
+				if (new_value != old_value) {
+					DoCommandP(0, new_value, 0, NULL, CMD_SET_SHARED_BOOL_VALUES);
+				}
+
+				/* pack other variables and check for change before sending command */
+				new_value = _si_tontile_cost | _si_road_stops_fee << 16 |  _si_harbours_fee << 24;
+				old_value = p->shared_tontile_cost[1] | p->shared_road_stops_fee[1] << 16 | p->shared_harbours_fee[1] << 24;
+
+				new_value2 = _si_landing_fee | _si_provision << 16;
+				old_value2 = p->shared_landing_fee[1] | p->shared_provision[1] << 16;
+
+				if (new_value != old_value || new_value2 != old_value2) {
+					DoCommandP(0, new_value, new_value2, NULL, CMD_SET_SHARED_INT_VALUES);
+				}
+
+				delete this;
+				break;
+
+			default:
+				if (widget >= SI_WIDGET_SHARED_RAILWAY_TRACKS && widget <= SI_WIDGET_SHARED_DEPOT_PROVISION_R) {
+						
+					if (widget < SI_WIDGET_SHARED_TONTILE_COST_L) { 
+						/* Bool buttons */
+						switch (widget - SI_WIDGET_SHARED_RAILWAY_TRACKS) {
+							default: NOT_REACHED();
+							case 0: 
+								_si_railway_tracks = !_si_railway_tracks;
+								/* close railway stations and depots if tracks are closed */
+								if (!_si_railway_tracks) {
+									_si_railway_stations = false;
+									_si_railway_depots = false;
+								}
+								break; 
+							case 1:
+								_si_railway_stations = !_si_railway_stations;
+								/* open tracks when opening railway stations */
+								if (_si_railway_stations) {
+									_si_railway_tracks = true;
+								}
+								break; 
+							case 2:
+								_si_railway_depots = !_si_railway_depots;
+								/* open tracks when opening railway depots */
+								if (_si_railway_depots) {
+									_si_railway_tracks = true;
+								}
+								break; 
+							case 3: _si_airports = !_si_airports; break; 
+							case 4: _si_road_depots = !_si_road_depots; break; 
+							case 5: _si_road_stops = !_si_road_stops; break; 
+							case 6: _si_water_depots = !_si_water_depots; break; 
+							case 7: _si_harbours = !_si_harbours; break; 
+						}
+					} else {
+						/** Value buttons
+						 * - get widget line
+						 * - get button click : 0 == left (_L), 1 == middle or 2 == right (_R)
+						 */
+						int line = (widget - SI_WIDGET_SHARED_TONTILE_COST_L) / 3;
+						bool add = (((widget - SI_WIDGET_SHARED_TONTILE_COST_L) % 3) != 0);
+						switch (line) {
+							default: NOT_REACHED();
+							/* "magic" step and max values based on those in settings.cpp */
+							case 0:
+								_si_tontile_cost += add ? 5 : -5;
+								if (_si_tontile_cost > 250) _si_tontile_cost = _si_tontile_cost > 255 ? 0 : 250;
+								break;
+							case 1:
+								_si_road_stops_fee += add ? 1 : -1;
+								if (_si_road_stops_fee > 50) _si_road_stops_fee = _si_road_stops_fee > 51 ? 0 : 100;
+								break;
+							case 2:
+								_si_harbours_fee += add ? 5 : -5;
+								if (_si_harbours_fee > 200) _si_harbours_fee = _si_harbours_fee > 205 ? 0 : 200;
+								break;
+							case 3:
+								_si_landing_fee += add ? 20 : -20;
+								if (_si_landing_fee > 1000) _si_landing_fee = _si_landing_fee > 1020 ? 0 : 1000;
+								break;
+							case 4:
+								_si_provision += add ? 5 : -5;
+								if (_si_provision > 100) _si_provision = _si_provision > 105 ? 0 : 100;
+								break;
+						}
+					}
+				}
+				this->SetDirty();
+				break;
+			}
+	}
+};
+
+static const WindowDesc _shared_infrastructure_desc = {
+	WDP_AUTO, WDP_AUTO, 270, 207, 270, 207,
+	WC_SHARED_INFRASTRUCTURE, WC_NONE,
+	WDF_STD_TOOLTIPS | WDF_STD_BTN | WDF_DEF_WIDGET | WDF_UNCLICK_BUTTONS, 
+	_shared_infrastructure_widgets, 
+};
+
+
+static void ShowPlayerSharedInfrastructure(Window *parent)
+{
+	if (!IsValidPlayer((PlayerID)parent->window_number)) return;
+
+	if (BringWindowToFrontById(WC_SHARED_INFRASTRUCTURE, parent->window_number)) return;
+	new SelectSharedInfrastructureWindow(&_shared_infrastructure_desc, parent); 
+}
+
 /* Names of the widgets. Keep them in the same order as in the widget array */
 enum PlayerCompanyWindowWidgets {
 	PCW_WIDGET_CLOSEBOX = 0,
@@ -1048,9 +1478,12 @@
 	PCW_WIDGET_COMPANY_NAME,
 	PCW_WIDGET_BUILD_VIEW_HQ,
 	PCW_WIDGET_RELOCATE_HQ,
+	PCW_WIDGET_CENTER,
+	PCW_WIDGET_OPEN,
 	PCW_WIDGET_BUY_SHARE,
 	PCW_WIDGET_SELL_SHARE,
 	PCW_WIDGET_COMPANY_PASSWORD,
+	PCW_WIDGET_COMPANY_SHARING,
 };
 
 static const Widget _player_company_widgets[] = {
@@ -1063,9 +1496,12 @@
 { WWT_PUSHTXTBTN,   RESIZE_NONE,    14,   270,   359,   158,   169, STR_7008_COMPANY_NAME,             STR_7033_CHANGE_THE_COMPANY_NAME},
 {    WWT_TEXTBTN,   RESIZE_NONE,    14,   266,   355,    18,    29, STR_7072_VIEW_HQ,                  STR_7070_BUILD_COMPANY_HEADQUARTERS},
 {    WWT_TEXTBTN,   RESIZE_NONE,    14,   266,   355,    32,    43, STR_RELOCATE_HQ,                   STR_RELOCATE_COMPANY_HEADQUARTERS},
+{ WWT_PUSHTXTBTN,   RESIZE_NONE,    14,   266,   355,    46,    57, STR_PLAYER_CENTER,                 STR_PLAYER_CENTER_VIEWPORT},
+{ WWT_PUSHTXTBTN,   RESIZE_NONE,    14,   266,   355,    60,    71, STR_PLAYER_OPEN,                   STR_PLAYER_OPEN_VIEWPORT},
 { WWT_PUSHTXTBTN,   RESIZE_NONE,    14,     0,   179,   158,   169, STR_7077_BUY_25_SHARE_IN_COMPANY,  STR_7079_BUY_25_SHARE_IN_THIS_COMPANY},
 { WWT_PUSHTXTBTN,   RESIZE_NONE,    14,   180,   359,   158,   169, STR_7078_SELL_25_SHARE_IN_COMPANY, STR_707A_SELL_25_SHARE_IN_THIS_COMPANY},
 { WWT_PUSHTXTBTN,   RESIZE_NONE,    14,   266,   355,   138,   149, STR_COMPANY_PASSWORD,              STR_COMPANY_PASSWORD_TOOLTIP},
+{    WWT_TEXTBTN,   RESIZE_NONE,    14,   266,   355,    46,    57, STR_COMPANY_SHARING,               STR_SET_COMPANY_SHARING},
 {   WIDGETS_END},
 };
 
@@ -1187,6 +1623,7 @@
 		this->SetWidgetHiddenState(PCW_WIDGET_BUY_SHARE,        local);
 		this->SetWidgetHiddenState(PCW_WIDGET_SELL_SHARE,       local);
 		this->SetWidgetHiddenState(PCW_WIDGET_COMPANY_PASSWORD, !local || !_networking);
+		this->SetWidgetHiddenState(PCW_WIDGET_COMPANY_SHARING, !_settings_game.sharing.shared_player_level);
 
 		if (!local) {
 			if (_settings_game.economy.allow_shares) { // Shares are allowed
@@ -1286,6 +1723,20 @@
 				this->InvalidateWidget(PCW_WIDGET_RELOCATE_HQ);
 				break;
 
+			case PCW_WIDGET_CENTER:
+				ScrollMainWindowToTile(GetPlayer((PlayerID)this->window_number)->last_build_coordinate);
+				break;
+
+			case PCW_WIDGET_OPEN: {
+				int window = ShowExtraViewPortWindow();
+				Player *p = GetPlayer((PlayerID)this->window_number);
+				TileIndex tile = p->last_build_coordinate;
+
+				p->window = window;
+				ScrollWindowTo(TileX(tile) * TILE_SIZE + TILE_SIZE / 2, TileY(tile) * TILE_SIZE + TILE_SIZE / 2, FindWindowById(WC_EXTRA_VIEW_PORT, window), true);
+				break;
+			}
+
 			case PCW_WIDGET_BUY_SHARE:
 				DoCommandP(0, this->window_number, 0, NULL, CMD_BUY_SHARE_IN_COMPANY | CMD_MSG(STR_707B_CAN_T_BUY_25_SHARE_IN_THIS));
 				break;
@@ -1293,6 +1744,10 @@
 			case PCW_WIDGET_SELL_SHARE:
 				DoCommandP(0, this->window_number, 0, NULL, CMD_SELL_SHARE_IN_COMPANY | CMD_MSG(STR_707C_CAN_T_SELL_25_SHARE_IN));
 				break;
+					
+			case PCW_WIDGET_COMPANY_SHARING:
+				ShowPlayerSharedInfrastructure(this);
+				break;
 
 #ifdef ENABLE_NETWORK
 			case PCW_WIDGET_COMPANY_PASSWORD:
Index: src/openttd.cpp
===================================================================
--- src/openttd.cpp	(revision 13683)
+++ src/openttd.cpp	(working copy)
@@ -744,7 +744,6 @@
 
 void StartupPlayers();
 void StartupDisasters();
-extern void StartupEconomy();
 
 /**
  * Start Scenario starts a new game based on a scenario.
Index: src/aircraft_cmd.cpp
===================================================================
--- src/aircraft_cmd.cpp	(revision 13683)
+++ src/aircraft_cmd.cpp	(working copy)
@@ -37,6 +37,7 @@
 #include "settings_type.h"
 #include "order_func.h"
 #include "effectvehicle_func.h"
+#include "sharedinfrastructure.h"
 
 #include "table/strings.h"
 #include "table/sprites.h"
@@ -117,7 +118,7 @@
 	TileIndex vtile = TileVirtXY(v->x_pos, v->y_pos);
 
 	FOR_ALL_STATIONS(st) {
-		if (st->owner != v->owner || !(st->facilities & FACIL_AIRPORT)) continue;
+		if (((st->owner != v->owner)&&(!SharedAirports(st->xy,v->owner))) || !(st->facilities & FACIL_AIRPORT)) continue;
 
 		const AirportFTAClass *afc = st->Airport();
 		if (afc->nof_depots == 0 || (
@@ -149,7 +150,7 @@
 
 	FOR_VEHICLE_ORDERS(v, order) {
 		const Station *st = GetStation(order->station);
-		if (st->owner == v->owner && st->facilities & FACIL_AIRPORT) {
+		if (((st->owner == v->owner)&&(!SharedAirports(st->xy,v->owner))) && st->facilities & FACIL_AIRPORT) {
 			/* If an airport doesn't have a hangar, skip it */
 			if (st->Airport()->nof_depots != 0)
 				return true;
@@ -274,7 +275,7 @@
 	/* to just query the cost, it is not neccessary to have a valid tile (automation/AI) */
 	if (flags & DC_QUERY_COST) return value;
 
-	if (!IsHangarTile(tile) || !IsTileOwner(tile, _current_player)) return CMD_ERROR;
+	if (!IsHangarTile(tile) || (!IsTileOwner(tile, _current_player) && !SharedAirports(tile, _current_player))) return CMD_ERROR;
 
 	/* Prevent building aircraft types at places which can't handle them */
 	if (!CanAircraftUseStation(p1, tile)) return CMD_ERROR;
@@ -454,6 +455,8 @@
 		GetPlayer(_current_player)->num_engines[p1]++;
 	}
 
+	SharedDepotProvision(value, GetTileOwner(tile), flags);
+
 	return value;
 }
 
@@ -1684,8 +1687,9 @@
 
 	/* runway busy or not allowed to use this airstation, circle */
 	if (apc->flags & (v->subtype == AIR_HELICOPTER ? AirportFTAClass::HELICOPTERS : AirportFTAClass::AIRPLANES) &&
+			!HASBITS(st->airport_flags, AIRPORT_CLOSED_block) &&
 			st->airport_tile != 0 &&
-			(st->owner == OWNER_NONE || st->owner == v->owner)) {
+			(st->owner == OWNER_NONE || st->owner == v->owner || SharedAirports(st->xy, v->owner))) {
 		// {32,FLYING,NOTHING_block,37}, {32,LANDING,N,33}, {32,HELILANDING,N,41},
 		// if it is an airplane, look for LANDING, for helicopter HELILANDING
 		// it is possible to choose from multiple landing runways, so loop until a free one is found
@@ -1700,6 +1704,10 @@
 				uint16 tsubspeed = v->subspeed;
 				if (!AirportHasBlock(v, current, apc)) {
 					v->u.air.state = landingtype; // LANDING / HELILANDING
+
+					/* check landing fee for shared airports */
+					if (st->owner != v->owner) SharedStationFee(st->owner, v->index);
+
 					/* it's a bit dirty, but I need to set position to next position, otherwise
 					 * if there are multiple runways, plane won't know which one it took (because
 					 * they all have heading LANDING). And also occupy that block! */
Index: src/genworld.h
===================================================================
--- src/genworld.h	(revision 13683)
+++ src/genworld.h	(working copy)
@@ -79,6 +79,7 @@
 void AbortGeneratingWorld();
 bool IsGeneratingWorldAborted();
 void HandleGeneratingWorldAbortion();
+void StartupEconomy();
 
 /* genworld_gui.cpp */
 void SetGeneratingWorldProgress(gwp_class cls, uint total);
Index: src/rail_map.h
===================================================================
--- src/rail_map.h	(revision 13683)
+++ src/rail_map.h	(working copy)
@@ -31,6 +31,8 @@
  */
 static inline RailTileType GetRailTileType(TileIndex t)
 {
+  	if(!IsTileType(t, MP_RAILWAY))
+		printf("tiletype: %i\n",GetTileType(t));
 	assert(IsTileType(t, MP_RAILWAY));
 	return (RailTileType)GB(_m[t].m5, 6, 2);
 }
